#!/opt/QtPalmtop/bin/zps
// This can be used as a bang script from the commandline....

/**
 * zPS SMPT email Sending Example.
 * As well as demonstrating the network interface, this script also demonstrates
 * a simplistic use of the ECMAScript try/throw/catch exception handling mechanism.
 * In addition, it can take parameters from the console, so if you make it executable
 * it can be run directly from the command line:
 * eg. To send the author a mail:
 *  smtp.js zpsTest@data-uncertain.co.uk "Testing zPS" "This is way cool :)"
 *
 * @author Craig Graham
 * @file smtp.js
 */

// The address of your smtp server...you need to edit this to be a mailserver you're
// allowed to use (eg. the one at your ISP).
var MAIL_SERVER="mail.mistral.co.uk";

// Function to send an email...
function sendMail(fromAddr,toAddr,subject,message)
{
	var server=new Host(MAIL_SERVER); // Creating a host object automaticly does a DNS lookup for you...
	var c=new Socket(Socket.PF_INET,Socket.SOCK_STREAM); // Create a TCP socket
	var tmp;
	var response;
	tmp=c.connect(server,25); // connect the socket to port 25 (SMTP) on the mailserver
	if(tmp) // connect returns true if it suceeded
	{
		// The actual SMTP protocol bit - this is wrapped in
		// a try{} structure to make it easy to handle to 
		// errors....
		try {
			c.lineEndMode=File.LINE_END_DOS; // As SMTP uses CRLF line ends
			response=c.readlnString(); Console.print(response+Console.lf);
			c.writeln("HELO zaurus");
			response=c.readlnString(); Console.print(response+Console.lf);
			tmp=response.substr(0,3);
			if(response.substr(0,3)!="250")
				throw "Server didn't like our HELO";
			c.writeln("MAIL FROM:<"+fromAddr+">");
			response=c.readlnString(); Console.print(response+Console.lf);
			if(response.substr(0,3)!="250")
				throw "Server didn't like our MAIL FROM";
			c.writeln("RCPT TO:<"+toAddr+">");
			response=c.readlnString(); Console.print(response+Console.lf);
			if(response.substr(0,3)!="250")
				throw "Server didn't like our RCPT TO";
			c.writeln("DATA");
			response=c.readlnString(); Console.print(response+Console.lf);
			if(response.substr(0,3)!="354")
				throw "Server didn't like our DATA";
			c.writeln("From:<"+fromAddr+">");
			c.writeln("To:<"+toAddr+">");
			c.writeln("Subject: "+subject);
			c.writeln("");
			c.writeln(message);
			c.writeln("");
			c.writeln(".");
			response=c.readlnString(); Console.print(response+Console.lf);
			if(response.substr(0,3)!="250")
				throw "Server didn't like the end of our data";
			c.writeln("QUIT");
			response=c.readlnString(); Console.print(response+Console.lf);
			if(response.substr(0,3)!="221")
				throw "Server didn't like our QUIT";
		}
		
		// catch any exceptions from the mail send code...
		catch (tmp) {
			Console.print("sendMail: caught exception="+tmp+Console.lf);
			return false; // return fail
		}
		
	}else{
		Console.print("couldn't connect to mailserver "+MAIL_SERVER);
		return false; // return fail
	}
	
	// Note that we don't bother deleting the socket and stuff
	// - they auto delete when the function exits...
	
	return true;
}

if(args.length==4)
{
	// Call our sendMail function to send an email...
	return (sendMail(
		"zpsTest@data-uncertain.co.uk",
		args[1],
		args[2],
		args[3])?"Mail sent ok":"Failled to send mail")+Console.lf;
}else{
	// wrong number of parameters, print the usage instructions...
	Console.print("usage:"+Console.lf);
	Console.print(" "+args[0]+" <toAddress> <subject> <messageBody>"+Console.lf);
}

// This is an example of calling the sendMail() function explicitly...
/*
sendMail(
	"zpsTest@data-uncertain.co.uk",
	"craig@data-uncertain.co.uk",
	"Latest Test3",
	"Hello World"+Console.lf+"Hello World");
*/


